%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%% Nadi 18/3/2015
%%%%%%%%%%% CinC Challenge 2015
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [RR, RRAvg, HRV, Rt, RAmp, RIndex]= ECGprocess(ECGsignal,Fsampl)

%%%%%%%%%% The function applied the preprocessing to the ECG signals (from 2 channels II and V), then 
%%%%%%%%%% detect QRS complexes and calculates RR intervals. Finally, 5 points running average is applied. 
%%%%%%%%%% The iputs are the ECG signals and sampling frequencies as
%%%%%%%%%% the inputs and gives the RR interval and QRS onsets and indices
%%%%%%%%%% as the outputs: 
%%%%%%%%%% RR2: the RR intervals in samples , RRAvg: 5 points running
%%%%%%%%%% average on RR, HRV: Heart Rate Variability, Rt: the times of R
%%%%%%%%%% peaks, Rqmp: the amplitude of R peaks, Rindex: the sample index
%%%%%%%%%% of R peaks

%%%%%%%%%%%%%%%%%%% ************  ECG II: ************ %%%%%%%%%%%%%%%%%%%%
ECG=ECGsignal;
% ECG=signal(:,1);
% Preprocessing:
% 1) Median filters:

F1=floor(0.2*Fsampl);
F2=floor(0.6*Fsampl);
b2=sortfilt1(ECG,F1,50);           % Median filter
b2=sortfilt1(b2,F2,50);
ECGmed = ECG-b2;                   % compute for approximately 5 min of data to prevent long time process

% R Peak Detection
% 1)My algorithm

% % 4) Hilbert transform; Philip's algorithm ***
% % SampleRate=Fs;
% % MyECG2=ECGmed2';
% % QRS2=qrsdethilbert(MyECG2,SampleRate);
% % % save(QRS2,QRS);
% % QRSECG2=ECGmed2(QRS2);

% 5) Cinc batch QRS detector of Pan, Hamilton and Tompkins 
[HRV, Rt, RAmp, RIndex, St, Samp]  = rpeakdetect(ECGmed,Fsampl,0.1);
%HRV=diff(QRS times)

% RR Interval
RR=diff(RIndex);
RR(end+1)=RR(end);

% *** Average 5 RRs
RRAvg=zeros(1,length(RIndex)-4);
for rr=3:(length(RIndex)-2)
    RRAvg(rr)=mean(RIndex(rr-2:rr+2));
end

%